Class AppointmentAPI
API class for reading and writing
Appointment entities.- Since:
- 6.5.0
- Author:
- XIMA MEDIA GmbH
-
Field Summary
Fields inherited from class AEntityAPI
entityClass -
Constructor Summary
Constructors -
Method Summary
Modifier and TypeMethodDescriptionvoidCancels the given appointment.Books the given appointment.getAllBy(UserContext uc, IAppointmentQueryParams queryParams) Returns all appointments that match the given query parameters.<View extends IEffectiveAppointmentStatusProviding>
List<View> getAttributesBy(UserContext uc, IAppointmentQueryParams params, Class<View> viewClass) Returns all the attributes of the appointments specified by theIAppointmentQueryParams.getBy(UserContext uc, de.xima.cmn.criteria.QueryCriteriaManager qcm, boolean eager) Finds the appointment with the givenQueryCriteriaManageran is able to load it eagerly.getByUUID(UserContext uc, String uuid) Finds the appointment with the given UUID.getByUUID(UserContext uc, String uuid, boolean eager) Finds the appointment with the given UUID an is able to load it eagerly.getByUUID(UserContext uc, UUID uuid) Finds the appointment with the given UUID.Moves an appointment to a different time and date.Validates whether the given appointments can be created or updated.Methods inherited from class AEntityAPI
create, create, delete, delete, deleteAllBy, deleteById, deleteById, getAll, getAllBy, getAttributes, getAttributes, getBy, getById, getById, getEntityRefs, getPagedResult, getSingleAttributes, getSingleAttributes, resultTotalCount, resultTotalCount, update, updateMethods inherited from class ASubAPI
getHandlerProvider
-
Constructor Details
-
AppointmentAPI
public AppointmentAPI()
-
-
Method Details
-
cancelBookedAppointment
public void cancelBookedAppointment(UserContext uc, IAppointmentDeleteBookingParams params) throws AppointmentBookingException Cancels the given appointment. You should callvalidateAppointments(UserContext, IAppointmentValidateParams)first if you have not done so yet.- Parameters:
uc- Current user context for accessing the database.params- Parameters with the appointment to cancel, must be a persisted entity.- Throws:
AppointmentBookingException- When the booking could not be performed. SeeAppointmentBookingException.getBookingError()for more details.
-
createBookedAppointment
public Appointment createBookedAppointment(UserContext uc, IAppointmentCreateBookingParams params) throws AppointmentBookingException Books the given appointment. You should callvalidateAppointments(UserContext, IAppointmentValidateParams)first if you have not done so yet.- Parameters:
uc- Current user context for accessing the database.params- Parameters with the appointment to book, must be a new (non-persisted) entity.- Returns:
- The persisted appointment.
- Throws:
AppointmentBookingException- When the booking could not be performed. SeeAppointmentBookingException.getBookingError()for more details.
-
getAllBy
Returns all appointments that match the given query parameters.- Parameters:
uc- Current user context for accessing the database.queryParams- Restrictions to apply the returned appointments.- Returns:
- All appointments that match the given query parameters.
-
getAttributesBy
public <View extends IEffectiveAppointmentStatusProviding> List<View> getAttributesBy(UserContext uc, IAppointmentQueryParams params, Class<View> viewClass) Returns all the attributes of the appointments specified by theIAppointmentQueryParams.- Parameters:
uc- User context for the database transaction.params- the appointment query paramsviewClass- the class of theIEffectiveAppointmentStatusProvidingimplementation- Returns:
- the attributes specified by the appointment query params
-
getByUUID
Finds the appointment with the given UUID.- Parameters:
uc- Current user context for accessing the database.uuid- UUID of an appointment.- Returns:
- The appointment with the given UUID.
-
getByUUID
Finds the appointment with the given UUID an is able to load it eagerly.- Parameters:
uc- Current user context for accessing the database.uuid- UUID of an appointment.eager- the flag to load the appointment eagerly.- Returns:
- The appointment with the given UUID.
-
getByUUID
Finds the appointment with the given UUID.- Parameters:
uc- Current user context for accessing the database.uuid- UUID of an appointment.- Returns:
- The appointment with the given UUID.
-
moveBookedAppointment
public Appointment moveBookedAppointment(UserContext uc, IAppointmentMoveBookingParams params) throws AppointmentBookingException Moves an appointment to a different time and date. You should callvalidateAppointments(UserContext, IAppointmentValidateParams)first if you have not done so yet.- Parameters:
uc- Current user context for accessing the database.params- Parameters with the appointment to move.- Returns:
- The updated appointment from the database.
- Throws:
AppointmentBookingException- When the booking could not be performed. SeeAppointmentBookingException.getBookingError()for more details.
-
validateAppointments
public List<EAppointmentBookingError> validateAppointments(UserContext uc, IAppointmentValidateParams params) Validates whether the given appointments can be created or updated.- Parameters:
uc- Current user context for accessing the database.params- Parameters with the appointments to validate.- Returns:
- The validation errors for each appointment.
-
getBy
public Appointment getBy(UserContext uc, de.xima.cmn.criteria.QueryCriteriaManager qcm, boolean eager) Finds the appointment with the givenQueryCriteriaManageran is able to load it eagerly.- Parameters:
uc- Current user context for accessing the database.qcm- Custom filter criteria for the appointment.eager- the flag to load the appointment eagerly.- Returns:
- The appointment with the given UUID.
-